# Create a task

> Source: https://docs.clonepartner.com/api-reference/tasks/create-task/

`POST /api/tasks`

Create a task

**Operation ID:** `createTask`

## Authentication

### Option 1

- **BearerAuth** (`http bearer`)
  API key token. Create via POST /api/api-keys. Format: `envoy_<hex>`

### Option 2

- **CookieAuth** (`apiKey`)
  Session cookie set after login + TOTP verification

## Request body

The request body is required.

### `application/json`

- Type: `object`
- Properties:
  - `name` (`string`, `required`)
  - `description` (`string`)
  - `yaml_content` (`string`, `required`) — Task definition in YAML format
  - `connector_refs` (`array<string>`)
    - Items:
      - Type: `string`

## Success responses

### 201

Task created with current YAML content

**Content type:** `application/json`

- Type: `Task & object`
- All of:
  - Variant 1:
    - Reference: `Task`
      - Type: `object`
      - Properties:
        - `id` (`integer`)
        - `name` (`string`)
        - `description` (`string | null`)
          - Nullable: yes
        - `current_version` (`integer`)
        - `status` (`string`)
          - Allowed values: `active`, `archived`
        - `created_at` (`string`)
          - Format: `date-time`
        - `updated_at` (`string`)
          - Format: `date-time`
  - Variant 2:
    - Type: `object`
    - Properties:
      - `current_yaml` (`string | null`)
        - Nullable: yes

## Error responses

### 400

Validation error

**Content type:** `application/json`

- Reference: `Error`
  - Type: `object`
  - Properties:
    - `error` (`string`)
      - Example: `NOT_FOUND`
    - `message` (`string`)
      - Example: `Resource not found`

Example:

```json
{
  "error": "VALIDATION_ERROR",
  "message": "Invalid input"
}
```

## Examples

### cURL

```bash
curl --request POST \
  --url 'https://your-envoy.example.com/api/tasks' \
  --header 'Authorization: Bearer $API_KEY' \
  --header 'Content-Type: application/json' \
  --data '{
  "name": "string",
  "yaml_content": "string"
}'
```

### JavaScript (fetch)

```javascript
const response = await fetch('https://your-envoy.example.com/api/tasks', {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer YOUR_API_KEY',
    'Content-Type': 'application/json',
  },
  body: JSON.stringify({
    "name": "string",
    "yaml_content": "string"
  }),
});

if (!response.ok) throw new Error(`Request failed: ${response.status}`);
const data = response.status === 204 ? null : await response.json();
console.log(data);
```
